#include <stdio.h>
#include <sman.h>

extern MODE ScoreFile, LevelsFile, GamesFile, ColorsFile;
extern FILE *fScore, *fLevels, *fGames, *fColors;
extern unsigned long Levels, HiScore, Colors3;

#define SCORE_FILE_NAME "top.dat"
#define LEVELS_FILE_NAME "levels.dat"
#define GAMES_FILE_NAME "games.dat"
#define COLORS_FILE_NAME "colors.dat"

#define SCORE_FILE_LEN 250
#define SAVED_GAMES_KOL 10

BEST Best[BEST_TABLE_LEN];
MODE DAY,MON; unsigned YEAR;

MODE ReadScore (void) { //NO - 訡 ⥭
 MODE i,Res;
 fScore=fopen (SCORE_FILE_NAME,"r+b");
 if (fScore==NULL) return NO;
 else {
  fseek (fScore, 0, SEEK_SET);
  for (i=0; i<BEST_TABLE_LEN; i++) {
   Res=fread (&Best[i],sizeof(BEST),1,fScore);
   if (Res!=1) {
	fclose (fScore);
	return NO;
   }
  }
 }
 return YES;
}

void GetDate (void) {
 asm { mov ah,2ah; int 21h ; mov DAY,dl; mov MON,dh; mov YEAR,cx; }
}

/* void GetTime (void) {
 asm { mov ah,2ch; int 21h; mov HOUR,ch; mov MIN,cl; }
} */

MODE WriteScore (void) { //NO - 訡 
 MODE i,j,Res; MODE *s="SpeedMan    ";
 fScore=fopen (SCORE_FILE_NAME,"wb");
 if (fScore==NULL) return NO;
 GetDate();
 for (i=0; i<BEST_TABLE_LEN; i++) {
  for (j=0; j<11; j++) Best[i].Name[j]=s[j];
  Best[i].Name[11]='\0';
  Best[i].Score=0;
  Best[i].Level=0;
  Best[i].Day=DAY;
  Best[i].Mon=MON;
  Best[i].Year=YEAR;
  Res=fwrite (&Best[i],sizeof(BEST),1,fScore);
  if (Res!=1) return NO;
 }
 fclose (fScore);
 return YES;
}

MODE ReadColors (void) {
 fpos_t Len;
 fColors=fopen (COLORS_FILE_NAME, "rb");
 if (fColors) {
  fseek (fColors, 0, SEEK_END);
  fgetpos (fColors, &Len);
  Colors3=Len/9;
  if (Colors3<1) return NO;
 }
 return YES;
}

MODE ReadGames () {
 fpos_t Size;
 fGames=fopen (GAMES_FILE_NAME,"r+b");
 if (fGames) {
  fseek (fGames,0,SEEK_END);
  fgetpos (fGames,&Size);
  if (Size==5*GAME_SIZE) return YES;
 }
 return NO;
}

MODE WriteGames (void) {
 extern MODE Level[];
 Object Default[5] = {
  {111,153,0x03,0x10,0x00},
  {87,140,0x00,11,0x01},
  {91,153,0x00,12,0xFF},
  {87,166,0x00,13,0x01},
  {91,153,0x00,14,0xFF},
 };
 Game DefGame = {
  1,1,1,1,1,
  3,18,182,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  72,0,630,810,0
 };
 int i,j,k=0;
 MODE *Name="Void\0\0\0\0";
 fGames=fopen (GAMES_FILE_NAME,"wb");
 if (fGames==NULL) return NO;
 for (i=0; i<5; i++) { //뢠 
  fwrite (Name,8,1,fGames);
  fwrite (&Level[0],ROWS*COLS,1,fGames);
  for (j=0; j<6; j++) fwrite (&k,2,1,fGames);
  for (j=0; j<5; j++) fwrite (&Default[j],sizeof(Object),1,fGames);
  k=fwrite (&DefGame,sizeof(Game),1,fGames);
  if (k!=1) return NO;
 }
 fclose (fGames);
 return YES;
}

void OpenFiles (void) {
 fpos_t Len;

 fLevels=fopen (LEVELS_FILE_NAME,"r+b");
 if (fLevels) {
  fseek (fLevels, 0, SEEK_END);
  fgetpos (fLevels, &Len);
  Levels=Len/403;
  if (Levels<1) goto NO_LEVELS;
  else LevelsFile=YES;
 }
 else {
NO_LEVELS:
  Levels=1;
  LevelsFile=NO;
 }

 ScoreFile=YES;
 if (ReadScore()==NO) {
  if (WriteScore ()) ScoreFile=ReadScore ();
  else ScoreFile=NO;
 }

 GamesFile=YES;
 if (ReadGames()==NO) {
  if (WriteGames ()) GamesFile=ReadGames ();
  else GamesFile=NO;
 }

 ColorsFile=ReadColors();
}
